<?php
/*
** fichier parse_flux-2.php
** utilis par la page exemple-4.php
*/

// chemin relatif vers le dossier cache
// le rpertoire "cache" doit tre autoris en criture
// ne pas oublier /  la fin
define(DIR_CACHE, 'cache/');

if (!is_dir(DIR_CACHE)) {
	exit ('Rpertoire cache "'.DIR_CACHE.'" inexistant !');
}

// fonction destine  nettoyer le texte rcupr
function clean_text($text, $encodage = '') {

	$text = str_replace('&lt;','<',$text);
	$text = str_replace('&gt;','>',$text);
	$text = str_replace('&quot;','"',$text);
	$text = str_replace('&amp;','&',$text);
	if ($encodage == 'utf-8') {
		$text = utf8_decode($text);
	}
	return $text;
}

include_once 'rss_read.inc.php';

function affiche_fil($fil, $file_cache, $delai, $n_items = 0) {

	// le fichier est-il en cache et suffisamment jeune
	$file_cache = DIR_CACHE.$file_cache;
	// $delai en secondes
	$delai = round($delai*3600);
	$rss = new rss_read();
	$date_modif = $rss -> get_last_modified($fil);

	if ($date_modif > 0) {
		$delai = 0;
	}
	else {
		$date_modif = time();
		$delai = $delai*3600;
	}
	
	$en_cache = file_exists($file_cache);
	if ($en_cache) {
		$en_cache = ($date_modif < filemtime($file_cache) + $delai);
	}
	
	if (!$en_cache) {
		// il est considr comme n'tant pas en cache on le gnre
		$data = '';
		
		// parser le fichier news
		$rss -> parsefile($fil, $n_items);
		
		if ($rss) {
			$encode = $rss -> get_encoding();
			
			// recupration des donnes sur le channel
			$channel = $rss -> get_channel();
			
			// affichage site, url, description 
			$data =  '<p><a href="'. $channel['link'].'" target="_blank">'. clean_text($channel['title'], $encode). '</a></p>';
			
			// nombre d'items 
			$nbnews = $rss -> get_num_items();
			
			// recup array des donnes 
			$items = $rss -> get_items();
			
			$data .= '<dl>';
			for($i = 0; $i < $nbnews; $i++) { 
				$data .= '<dt>- <a href="'.$items[$i]['link'].'" target="_blank">'.clean_text($items[$i]['title'], $encode).'</a></dt>'."\n"; 
			}
			
			$data .= '</dl>';
		} // fin if $rss
		
		$fd = fopen($file_cache, "w");
		fputs($fd, $data);
		fclose($fd);
	
	} // fin if $en_cache
	
	include $file_cache;
} // fin affiche_fil
?>